/* SPDX-License-Identifier: GPL-2.0 */
/*
 * Encoder core interface header
 *
 * Copyright (c) Imagination Technologies Ltd.
 * Copyright (c) 2018 Texas Instruments Incorporated - http://www.ti.com/
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation version 2.
 *
 * This program is distributed "as is" WITHOUT ANY WARRANTY of any
 * kind, whether express or implied; without even the implied warranty
 * of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 */

#ifndef __TOPAZ_API_H__
#define __TOPAZ_API_H__

#include "fw_headers/topazscfwif.h"
#include "fw_headers/vxe_common.h"
#include "osal/inc/osa_define.h"
#include "osal/inc/osa_types.h"
#include "vid_buf.h"
#include "lst.h"

#define MAX_MVC_VIEWS       2
#define MVC_BASE_VIEW_IDX   0
#define NON_MVC_VIEW        (~0x0)

#define MVC_SPS_ID          1
#define MVC_PPS_ID          1

#define NUM_SLICE_TYPES     5

/*
 * This type defines the buffer type categories.
 * @brief  Buffer Types
 */
enum venc_buf_type {
	VENC_BUFTYPE_BITSTREAM = 0,
	VENC_BUFTYPE_PICTURE,
	VENC_BUFTYPE_ALL,
	VENC_BUFTYPE_MAX,
	VENC_BUFTYPE_FORCE32BITS = 0x7FFFFFFFU
};

/*
 * VXE callback type definitions
 */
enum vxe_cb_type {
	VXE_CB_CODED_BUFF_READY,
	VXE_CB_SRC_FRAME_RELEASE,
	VXE_CB_STR_END,
	VXE_CB_ERROR_FATAL,
	VXE_CB_FORCE32BITS = 0x7FFFFFFFU
};

typedef void (*vxe_cb)(void *ctx, enum vxe_cb_type type, void *buf_ref, uint32 size, uint32 coded_frm_cnt);

/*
 * Enum specifying video encode profile
 */
enum img_video_enc_profile {
	ENC_PROFILE_DEFAULT = 0,
	ENC_PROFILE_LOWCOMPLEXITY,
	ENC_PROFILE_HIGHCOMPLEXITY,
	ENC_PROFILE_REDUCEDMODE,
	ENC_PROFILE_FORCE32BITS = 0x7FFFFFFFU
};

/*
 * Enum describing smallest blocksize used during motion search
 */
enum img_ipe_minblock_size {
	BLK_SZ_16x16 = 0,
	BLK_SZ_8x8 = 1,
	BLK_SZ_4x4 = 2,
	BLK_SZ_DEFAULT = 3,
	BLK_SZ_FORCE32BITS = 0x7FFFFFFFU
};

/*
 * Struct specifing flags to enable/disable encode features.
 * All boolean flags are FALSE by default
 */
struct img_encode_features {
	uint16				disable_intra4x4;
	uint16				disable_intra8x8;
	uint16				disable_intra16x16;
	uint16				disable_inter8x8;
	uint16				restrict_inter4x4;
	uint16				disable_bpic_ref1;
	uint16				disable_bpic_ref0;
	uint16				enable_8x16_mv_detect;
	uint16				enable_16x8_mv_detect;
	uint16				disable_bframes;
	enum img_ipe_minblock_size	min_blk_sz;
	uint16				restricted_intra_pred;
};

/*
 *
 * Struct describing Macro-block params generated by first stage.
 * Refer T.R.M. for details
 */
struct img_first_stage_mb_params {
	uint16		ipe0_sad;
	uint16		ipe1_sad;
	uint8		ipe0_blks;
	uint8		ipe1_blks;
	uint8		carc_cmplx_val;
	uint8		reserved;
};

/*
 * Size of Inter/Intra & Coded/Skipped tables
 */
#define TOPAZHP_SCALE_TBL_SZ                    (8)
#define DEFAULT_CABAC_DB_MARGIN    (0x190)

/*
 * Struct describing params for video encoding
 */
struct img_video_params {
	enum img_standard	standard;
	enum img_format		format;
	enum img_csc_preset	csc_preset;
	uint8			slices_per_picture;
	uint16			width;
	uint16			frame_height;
	osa_bool		is_interlaced;
	osa_bool		is_interleaved;
	osa_bool		constrained_intra;
	osa_bool		h264_8x8;
	osa_bool		bottom_field_first;
	osa_bool		arbitrary_so;
	osa_bool		cabac_enabled;
	uint32			cabac_bin_limit;
	uint32			cabac_bin_flex;
	uint8			deblock_idc;
	osa_bool		output_reconstructed;
	uint32			f_code;
	int32			fine_y_search_size;
	osa_bool		no_offscreen_mv;
	uint32			idr_period;

	uint32			intra_cnt;
	uint32			vop_time_resolution;
	struct img_encode_features	enc_features;
	uint8			enable_sel_stats_flags;	/* Flags to enable selective first-pass statistics gathering by the hardware. Bit 1 - First Stage Motion Search Data, Bit 2 - Best Multipass MB Decision Data, Bit 3 - Best Multipass Motion Vectors. (First stage Table 2 motion vectors are always switched on) */
	osa_bool		enable_inp_ctrl;			/* Enable Macro-block input control */
	osa_bool		enable_air;				/* Enable Adaptive Intra Refresh */
	int32			num_air_mbs;			/* n = Max number of AIR MBs per frame, 0 = _ALL_ MBs over threshold will be marked as AIR Intras, -1 = Auto 10% */
	int32			air_threshold;		/* n = SAD Threshold above which a MB is a AIR MB candidate,  -1 = Auto adjusting threshold */
	int16			air_skip_cnt;			/* n = Number of MBs to skip in AIR Table between frames, -1 = Random (0 - NumAIRMbs) skip between frames in AIR table */

	osa_bool		enable_cumulative_biases;
	osa_bool		enable_host_bias;
	osa_bool		enable_host_qp;
	osa_bool		use_default_scaling_list;
	int16			use_custom_scaling_lists;
	uint16			pps_scaling;
	uint32			vert_mv_limit;
	uint32			intra_pred_modes;

	uint16			limit_num_vectors;
	uint16			disable_bit_stuffing;	/* Disabling bitstuffing to maintain bitrate */

	uint8			coded_skipped_index;
	uint8			inter_intra_index;
	uint8			mpeg2_intra_dc_precision;	/* Only used in MPEG2, 2 bit field (0 = 8 bit, 1 = 9 bit, 2 = 10 bit and 3=11 bit precision). Set to zero for other encode standards. */

	/* Contents Adaptive Rate Control parameters */
	uint16			carc;
	int32			carc_baseline;
	uint32			carc_threshold;
	uint32			carc_cutoff;
	uint32			carc_neg_range;
	uint32			carc_neg_scale;
	uint32			carc_pos_range;
	uint32			carc_pos_scale;
	uint32			carc_shift;

	/* Weighted prediction */
	osa_bool		weighted_prediction;
	uint8			vp_weighted_implicit_bi_pred;

	/* SEI insertion */
	osa_bool		insert_hrd_params;

	uint16			intra_refresh;

	uint32			chunks_per_mb;
	uint32			max_chunks;
	uint32			priority_chunks;
	uint32			mbps;

	osa_bool		multi_reference_p;
	uint8			ref_spacing;
	osa_bool		spatial_direct;

	uint16			vp_adaptive_rounding_disable;
	uint16			vp_adaptive_rounding_offsets[18][4];

	uint32			debug_crcs;

	osa_bool		enable_mvc;			/* True if MVC is enabled. False by default */
	uint16			mvc_view_idx;			/* MVC view index */
	osa_bool		high_latency;

	uint16			buffer_stride_bytes;
	uint16			buffer_height;
	osa_bool		disable_bh_rounding;		/* True if we wish to disable the buffer height rounding to 16 pixels (enables contiguous YU memory for non-aligned image heights)	*/
	uint16			source_width;
	uint16			source_frame_height;

	osa_bool		no_sequence_headers;
	osa_bool		auto_encode;
	osa_bool		slice_level;
	osa_bool		coded_header_per_slice;

	osa_bool		auto_expand_pipes;	/* Automatically expand a context pipe allocations when new pipes become available */
	osa_bool		enable_lossless;
	osa_bool		lossless_8x8_prefilter;

	osa_bool		enable_scaler;
	uint16			crop_left;
	uint16			crop_right;
	uint16			crop_top;
	uint16			crop_bottom;

#if SECURE_IO_PORTS
	osa_bool		secure_ctx_input;
	osa_bool		secure_ctx_output;
#endif
	/* Low latency encoding related */
	osa_bool		line_counter_enabled;		//<! Drives the activation of low-latency encoding */
};

/*
 * Struct describing JPEG component info
 */
struct component_info {
	uint32	width;		/* Width of the image component */
	uint32	stride;		/* Stride of the image component */
	uint32	step;		/* Step of the image component */
	uint32	height;		/* Height of the image component */
};

/*
 * Struct describing JPEG info
 */
struct img_unaligned_source_info {
	uint32	output_width;		/* Width of the JPEG image */
	uint32	output_height;		/* Height of the JPEG image */
	uint32	components;			/* Number of components in the image ( 1 or 3 ) */
	struct component_info comp_info[3];			/* Array containing component info */
};

/*
 * Struct containing details of a reconstuctured picture
 */
struct img_recon_done {
	uint32	poc;					/* PicOrderCount */
	void	*buffer;					/* Buffer containing reconstructured image */
};

/*
 * Struct containing a feedback for one frame
 */
struct img_feedback_element {
	osa_bool		is_coded;							/* Is the frame was coded or skipped completely? */
	osa_bool		is_skipped;							/* Is the frame coded as a set of skipped MBs? */
	osa_bool		entire_frame;						/* Was the frame encoded entirely or there a still slices to come? */
	enum img_frame_type 	frame_type;							/* Frame Type (IDR, I, P, B) */
	uint8			source_slot;						/* Number of the source slot, containing the source buffer */
	uint8			recon_idx;						/* Number of the slot, conaining reconstructed picture */
	struct img_frame	*src_frame;							/* Source buffer */
	struct img_buffer	*motion_search_statistics_buf;			/* Buffer to contain Table 1 (8 byte Motion Search Data) of the selectable stats */
	struct img_buffer	*best_multipass_statistics_buf;		/* Buffer to contain (optionally) Table 4 (64 bytes Multipass Motion Vectors) and table 3 (16 byte Multipass Parameters) */

	struct coded_package_host *coded_package;					/* Pointer to the coded package, containing the returned header and coded buffer information */

	struct list_item 	*recon_list;						/* List of reconstructed pictures */
	uint32			bytes_coded;						/* Size of the encoded slice in bytes */
	uint32			first_bu;						/* Number of the first BU in the slice */
	uint8			storage_frame_num;					/* Last 2 bits of the Frame number in Storage Order */
	uint8			slice_num;						/* Number of the slice in a Slice Map supplied */
	uint8			slices_per_picture;				/* Number of the slices in this picture */
	uint8			field;							/* The field this slice belongs to */
	uint8			coded_slot_num;					/* Slot number of the coded buffer */

	uint8			active_coded_package_idx;

	uint32			poc;							/* PicOrderCount of the coded slice */
	osa_bool		patched_recon;						/* Was the reconstructed picture written to a patched buffer? */
	uint8			slices_in_buffer;					/* Number of slices contained in the coded buffer */
	osa_bool		last_frame_encoded;				/* True if the last frame has been encoded */
	uint8			coded_buffer_count;				/* Number of coded buffer used */

	uint64          host_ctx;								/* Host context value */
};

/*
 * Bit fields for ui32CoreFeatures
 */
#define SCALER_SUPPORTED_MASK					0x00000080
#define GENERATE_PERFORMANCE_STORE_MASK			0x00000100
#define H264_LOSSLESS_SUPPORTED_MASK			0x00000200
#define H264_CUSTOM_QUANT_SUPPORTED_MASK		0x00000400
#define MPEG2_SUPPORTED_MASK					0x00000800
#define SIGNATURES_SUPPORTED_SUBSET_MASK		0x00001000
#define SIGNATURES_SUPPORTED_ALL_MASK			0x00002000
#define H264_WEIGHTED_PRED_ME_SUPPORTED_MASK	0x00004000
#define H264_WEIGHTED_PRED_SUPPORTED_MASK		0x00008000
#define H264_2_REF_ON_P_PIC_SUPPORTED_MASK		0x00010000
#define H264_SPATIAL_DIRECT_SUPPORTED_MASK		0x00020000
#define H264_MULTIPASS_SUPPORTED_MASK			0x00040000
#define H264_DEFAULT_TABLES_SUPPORTED_MASK		0x00080000
#define H264_8X8_TRANSFORM_SUPPORTED_MASK		0x00100000
#define H264_INTERLACED_SUPPORTED_MASK			0x00200000
#define H264_B_PIC_SUPPORTED_MASK				0x00400000
#define H264_16X8_8X16_SUPPORTED_MASK			0x00800000
#define H264_CABAC_SUPPORTED_MASK				0x01000000
#define SLAVE_JPEG_SUPPORTED_MASK				0x02000000
#define JPEG_SUPPORTED_MASK						0x04000000
#define H263_SUPPORTED_MASK						0x08000000
#define MPEG4_SUPPORTED_MASK					0x10000000
#define H264_SUPPORTED_MASK						0x20000000
#define DMAC_SUPPORTED_MASK						0x40000000
#define MMU_SUPPORTED_MASK						0x80000000

/*
 * Struct describing the capabilities of the encoder
 */
struct img_enc_caps {
	uint16	min_slices;			/* Minimum slices to use */
	uint16	max_slices;			/* Maximum slices to use */
	uint16	recommended_slices;	/* Recommended number of slices */
	uint32	num_cores;			/* Number of cores that will be used */
	uint32	core_features;		/* Core features flags */
	uint32	core_revision;		/* Core revision */
	uint32	max_height;			/* Maximum height supported */
	uint32	max_width;			/* Maximum width supported */
	uint32	min_height;			/* Minimum height supported */
	uint32	min_width;			/* Minimum width supported */
	uint32	max_mb_num;			/* Maximum number of macro blocks */
	uint32	min_slice_height;		/* Minimum number of rows that a slice can span (not including automatic slice breaks) */
	uint32  max_bu_per_frame;		/* Maximum number of basic units per frame */
};

/*
 * Struct describing driver results message
 */
struct driver_tohost_msg {
	enum mtx_message_id	cmd_id;
	enum mtx_cmd_id		input_cmd_id;
	uint32			data;
	struct vidio_ddbufinfo	*command_data_buf;
	struct img_feedback_element	feedback;
};

/*
 * Enum describing picture coding type
 */

enum h264_picture_coding_type {
	I_FRAME = 0,		/* An intra frame */
	P_FRAME = 1,		/* An inter frame */
	B_FRAME = 2,			/* A B frame */
	FRAME_TYPE_FORCE32BITS = 0x7FFFFFFFU
};

/*
 * Struct describing H264 VUI parameters
 */
struct h264_vui_params {
	uint32	time_scale;									/* Time scale as defined in the H.264 specification */
	uint32	bit_rate_value_minus1;						/* An inter framebitrate/64)-1 */
	uint32	cbp_size_value_minus1;						/* An inter frame(bitrate*1.5)/16 */
	uint8   aspect_ratio_info_present_flag;             /* aspect_ratio_info_present_flag as defined in the H.264 specification */
	uint8	aspect_ratio_idc;                           /* as defined in the H.264 specification */
	uint16  sar_width;
	uint16  sar_height;
	uint8	cbr;										/* CBR as defined in the H.264 specification */
	uint8	initial_cpb_removal_delay_length_minus1;	/* as defined in the H.264 specification */
	uint8	cpb_removal_delay_length_minus1;			/* as defined in the H.264 specification */
	uint8	dpb_output_delay_length_minus1;				/* as defined in the H.264 specification */
	uint8	time_offset_length;							/* as defined in the H.264 specification */
	uint8	num_reorder_frames;
	uint8	max_dec_frame_buffering;
};

/*
 * Struct describing H264 crop parameters
 */
struct h264_crop_params
{
	osa_bool	clip;							/* Flag indicating if cropping parameters are present */
	uint16	left_crop_offset;						/* Number of pixels to crop from the left side /2 */
	uint16	right_crop_offset;						/* Number of pixels to crop from the right side /2 */
	uint16	top_crop_offset;						/* Number of pixels to crop from the top /2 */
	uint16	bottom_crop_offset;						/* Number of pixels to crop from the bottom /2 */
};

/*
 * Enum describing Profile (H264)
 */
enum sh_profile_type {
	SH_PROFILE_BP = 0,								/* H.264 Baseline Profile */
	SH_PROFILE_MP = 1,								/* H.264 Main Profile */
	SH_PROFILE_HP = 2,								/* H.264 High Profile */
	SH_PROFILE_H10P = 3,							/* H.264 High 10P Profile */
	SH_PROFILE_H422P = 4,							/* H.264 High 4:2:2 Profile */
	SH_PROFILE_H444P = 5,							/* H.264 High 4:4:4 Profile */
	SH_PROFILE_FORCE32BITS = 0x7FFFFFFFU
};

/*
 * Enum describing level (H264)
 */
enum sh_level_type {
	SH_LEVEL_1 = 10,								/* H264 Level as specified in the specification */
	SH_LEVEL_1B = 1,								/* Special-case H264 Level */
	SH_LEVEL_11 = 11,								/* H264 Level as specified in the specification */
	SH_LEVEL_12 = 12,								/* H264 Level as specified in the specification */
	SH_LEVEL_13 = 13,								/* H264 Level as specified in the specification */
	SH_LEVEL_2 = 20,								/* H264 Level as specified in the specification */
	SH_LEVEL_21 = 21,								/* H264 Level as specified in the specification */
	SH_LEVEL_22 = 22,								/* H264 Level as specified in the specification */
	SH_LEVEL_3 = 30,								/* H264 Level as specified in the specification */
	SH_LEVEL_31 = 31,								/* H264 Level as specified in the specification */
	SH_LEVEL_32 = 32,								/* H264 Level as specified in the specification */
	SH_LEVEL_4 = 40,								/* H264 Level as specified in the specification */
	SH_LEVEL_41 = 41,								/* H264 Level as specified in the specification */
	SH_LEVEL_42 = 42,								/* H264 Level as specified in the specification */
	SH_LEVEL_5 = 50,								/* H264 Level as specified in the specification */
	SH_LEVEL_51 = 51,								/* H264 Level as specified in the specification */
	SH_LEVEL_52 = 52,								/* H264 Level as specified in the specification */
	SH_LEVEL_FORCE32BITS = 0x7FFFFFFFU
};

/*
 * Struct describing SPS (sequence) parameters (H264)
 */
struct h264_sequence_header_params {
	enum sh_profile_type	profile;
	enum sh_level_type	level;
	uint8			width_in_mbs_minus1;
	uint8			height_in_maps_units_minus1;
	uint8			log2_max_pic_order_cnt;
	uint8			max_num_ref_frames;
	uint8		gaps_in_frame_num_value;
	uint8		frame_mbs_only_flag;
	uint8		vui_params_present;
	uint8		seq_scaling_matrix_present_flag;

	osa_bool	use_default_scaling_list;
	osa_bool	is_lossless;
	struct h264_vui_params	vui_params;
};

/*
 * Struct describing Bias parameters
 */
struct img_henc_debug_settings {
	uint32	serialized_communication_mode;
};

#define VXE_SERIALIZED_MODE_OFF		(0)
#define VXE_SERIALIZED_MODE_SYNCED	(1)
#define VXE_SERIALIZED_MODE_SERIAL	(2)

/*
 * Struct describing input parameters to encode a video picture
 */
struct pic_params {
	uint32			flags;				/* Picture parameter flags */
	struct in_rc_params	in_params;	/* Rate control parameters */
};

/*
 * Video encode context
 */
 struct img_video_context {
	/* topaz dd str context handle */
	void	*dd_str_ctx;		/* Pointer to device instance data */
	uint32	dd_ctx_num;

	/* stream level params */
	enum img_standard	standard;             	/* Video standard */
	uint16			width;              /* target output width */
	uint16			frame_height;        /* target output height */
	uint16			picture_height;      /* target output height */
	uint16			buffer_stride_bytes;        /* input buffer stride */
	uint16			buffer_height;       /* input buffer width */
	uint8			frame_rate;

	uint16			unrounded_width;
	uint16			unrounded_frame_height;

	uint32			debug_crcs;
	enum img_format		format;		/* Pixel format of the source surface */
	enum img_csc_preset	csc_preset; /* Colour space conversion to be performed on the source surface */

	/* Numbers of array elements that will be allocated */
	int32		pic_nodes;
	int32		mv_stores;

	/* per core params */
	struct pic_params	pic_params;  /* Picture level parameters (supplied by driver) */
	struct vidio_ddbufinfo	above_params[TOPAZHP_MAX_NUM_PIPES];  /* Picture level parameters (supplied by driver) */
	struct vidio_ddbufinfo	recon_pictures[MAX_PIC_NODES];	/* Reference pictures (2 input and 1 output) */
	struct vidio_ddbufinfo	colocated[MAX_PIC_NODES];		/* Colocated vector stores (2 input and 1 output) */
	struct vidio_ddbufinfo	mv[MAX_MV];						/* Vector stores */
	struct vidio_ddbufinfo	inter_view_mv[2];					/* Inter-view vector stores */

	/* partially coded headers supplied to HW */
	/* SEI_INSERTION */
	struct vidio_ddbufinfo	aud_header_mem;
	struct vidio_ddbufinfo	sei_buffering_period_header_mem;
	struct vidio_ddbufinfo	sei_picture_timing_header_mem;

	struct vidio_ddbufinfo	seq_header_mem;                          /* Partially coded Sequence header */
	struct vidio_ddbufinfo	subset_seq_header_mem;                    /* Partially coded Subset sequence header for H264 mvc */
	struct vidio_ddbufinfo	pichdr_template_mem[4];
	struct vidio_ddbufinfo	slice_params_template_mem[NUM_SLICE_TYPES];

	uint32	f_code;
	struct vidio_ddbufinfo	src_phys_addr;

	/* WEIGHTED PREDICTION */
	struct vidio_ddbufinfo	weighted_prediction_mem[MAX_SOURCE_SLOTS_SL];
	osa_bool		weighted_prediction;
	uint8 			weighted_bi_pred;

	struct vidio_ddbufinfo	flat_gop_struct;                          	/* Flat MiniGop structure */
	struct vidio_ddbufinfo	hierar_gop_struct;                           /* Hierarchical MiniGop structure */

	struct vidio_ddbufinfo	ltref_header[MAX_SOURCE_SLOTS_SL];

	struct vidio_ddbufinfo	custom_quant[2];				/* Custom quantization values */
	struct vidio_ddbufinfo	custom_quant_regs4x4_sp[2];		/* Custom quantization register values for 4x4 Sp */
	struct vidio_ddbufinfo	custom_quant_regs8x8_sp[2];		/* Custom quantization register values for 8x8 Sp */
	struct vidio_ddbufinfo	custom_quant_regs4x4_q[2];		/* Custom quantization register values for 4x4 Q */
	struct vidio_ddbufinfo	custom_quant_regs8x8_q[2];		/* Custom quantization register values for 8x8 Q */
	uint8			custom_quant_slot;

	struct img_buffer	slice_map[MAX_SOURCE_SLOTS_SL];                      /* Slice map of the source picture */

	struct img_buffer	firstpass_out_param_buf[MAX_SOURCE_SLOTS_SL];              /* Output Parameters of the First Pass */

	struct img_buffer	firstpass_out_best_multipass_param_buf[MAX_SOURCE_SLOTS_SL];  /* Output Selectable Best MV Parameters of the First Pass */
	struct img_buffer	mb_ctrl_in_params_buf[MAX_SOURCE_SLOTS_SL];                 /* Input Parameters to the second pass */

	/* these values set at picture level & written in at slice */
	uint32			ipe_control;         /* common bits IPE control register for entire picture  */
	uint32  		pred_comb_control;    /* common bits of Predictor-combiner control register for entire picture */
	osa_bool		cabac_enabled;          /* FLAG to enable Cabac mode */
	uint32  		cabac_bin_limit;      /* Min Bin Limit after which the Topaz hardware would encode MB as IPCM */
	uint32  		cabac_bin_flex;       /* Max Flex-Limit, the Topaz-HW will encode MB as IPCM after (BinLimit+BinFlex) */

	uint32  		first_pic_flags;
	uint32  		non_first_pic_flags;

	osa_bool		is_interlaced;
	osa_bool		is_interleaved;
	osa_bool		top_field_first;
	osa_bool		arbitrary_so;
	uint8			slices_per_picture;
	uint8			deblock_idc;
	uint32			kick_size;
	uint32  		kicks_per_bu;
	uint32			vop_time_resolution;
	uint32			idr_period;
	uint32			intra_cnt;
	osa_bool    		multi_reference_p;
	osa_bool    		spatial_direct;

	struct img_mv_settings	mv_settings_idr;
	struct img_mv_settings	mv_settings_non_b[MAX_BFRAMES + 1];

	/*  | MVSetingsB0 | MVSetingsB1 | ... | MVSetings Bn |  */

	struct vidio_ddbufinfo	mv_settings_btable;						/* three colocated vector stores (2 input and 1 output) */
	struct vidio_ddbufinfo	mv_settings_hierarchical;

	/* Source slots */
	struct img_frame	*source_slot_buff[MAX_SOURCE_SLOTS_SL];		/* Source slots */
	uint32			source_slot_poc[MAX_SOURCE_SLOTS_SL];	/* POCs of frames in slots */
	uint8			slots_in_use;				/* Number of source slots */
	uint8			slots_required;				/* Number of source slots to be consumed */

	/* Coded slots */
	struct coded_package_host	*coded_package[MAX_CODED_PACKAGES];	/* Collection of coded/header information */
	uint32 coded_buffer_max_size;
	uint8 coded_package_max_num;

	uint32			frame_count;
	uint32			flush_at_frame;
	uint32			flushed_at_frame;
	uint32			encode_sent;
	uint32			encode_requested;
	uint32			frames_encoded;
	osa_bool		encoder_idle;		/* Indicates that the encoder is waiting for data, Set to true at start of encode */
	osa_bool		aborted;

	struct list_item	*ref_frame;
	uint32			recon_poc;
	uint32			next_recon;

	struct vidio_ddbufinfo	*recon_buffer;
	struct vidio_ddbufinfo	*patched_recon_buffer;

	struct img_rc_params	rc_params;
	enum img_frame_type	frame_type;

	uint32 			buffers_status_reg;

	osa_bool		insert_seq_header;
	osa_bool		output_reconstructed;

	uint32			encode_pic_processing;
	uint8			extra_wb_retrieved;

	uint8   		enable_sel_stats_flags;   /* Flags to enable selective first-pass statistics gathering by the hardware. Bit 1 - First Stage Motion Search Data, Bit 2 - Best Multipass MB Decision Data, Bit 3 - Best Multipass Motion Vectors. (First stage Table 2 motion vectors are always switched on) */

	osa_bool    		enable_inp_ctrl;     /* Enable Macro-block input control */
	osa_bool		enable_air;			/* Enable Adaptive Intra Refresh */
	int32			num_air_mbs;	/* n = Max number of AIR MBs per frame, 0 = _ALL_ MBs over threshold will be marked as AIR Intras, -1 = Auto 10% */
	int32			air_threshold;	/* n = SAD Threshold above which a MB is a AIR MB candidate,  -1 = Auto adjusting threshold */
	int16			air_skip_cnt;	/* n = Number of MBs to skip in AIR Table between frames, -1 = Random (0 - NumAIRMbs) skip between frames in AIR table */

	osa_bool		enable_host_bias;
	osa_bool		enable_host_qp;

	osa_bool		custom_scaling;
	osa_bool		pps_scaling;
	osa_bool		h264_8x8_transform;
	osa_bool		h264_intra_constrained;
	uint32			vert_mv_limit;
	uint32			intra_pred_modes;
	osa_bool		limit_num_vectors;
	osa_bool		disable_bit_stuffing;
	uint8			coded_skipped_index;
	uint8			inter_intra_index;
	struct vidio_ddbufinfo mtx_enc_ctx_mem;
	/* SEI_INSERTION */
	osa_bool		insert_hrd_params;
	uint32 			chunks_per_mb;
	uint32			max_chunks;
	uint32			priority_chunks;

	uint8			source_slot_reserved;
	uint8			coded_package_slot_reserved;
	void 			*encode_pic_signal;

	uint8			highest_storage_number;
	uint8			vid_ctx_num;
	osa_bool        	enable_mvc;         /* True if MVC is enabled. False by default */
	uint16      		mvc_view_idx;     /* View Idx of this MVC view */
	osa_bool		high_latency;
	uint32			mbps;

	osa_bool		no_sequence_headers;
	uint32			next_slice;
	osa_bool		auto_encode;
	osa_bool		slice_level;
	osa_bool		coded_header_per_slice;

	/* Scaler specific values */
	osa_bool		enable_scaler;
	uint16			crop_left;
	uint16			crop_right;
	uint16			crop_top;
	uint16			crop_bottom;
	uint16			source_width;
	uint16			source_frame_height;

#if SECURE_IO_PORTS
	osa_bool		secure_ctx_input;
	osa_bool		secure_ctx_output;
#endif
	osa_bool	line_counter;		/* Keep track of line counter activation */
};

/*
 * Encoder context
 */
struct img_enc_context {
	enum img_codec	codec; 	/* encode codec */
	struct img_video_context *video;                   	/* Video encode context */

	uint8		base_pipe;		/* The first of a contiguous set of pipes to use for the context encode */
	uint8		pipes_to_use;		/* The number of contiguous pipes (starting with ui8BasePipe) to use for the context encode */

	uint8		requested_base_pipe;		/* The first of a contiguous set of pipes to use for the context encode */
	uint8		requested_pipes_to_use;		/* The number of contiguous pipes (starting with ui8BasePipe) to use for the context encode */
	osa_bool	auto_expand_pipes;	/* Automatically expand a context pipe allocations when new pipes become available */

	uint8		ctx_num;

	osa_bool	sync_first_pass;	/* true if never synced */
	uint32		core_rev;

	struct img_enc_caps caps;
	struct img_henc_debug_settings	*debug_settings;
};

/*
 * Struct containing details of a reconstuctured picture
 */
struct img_recon_node {
	uint32	poc; 	/* PicOrderCount */
	void	*buffer;	/* Buffer containing reconstructured image */
};

/*
 * This structure contains the topaz Context.
 * @brief  topaz Context
 */
struct topaz_core_context {
	/* List of stream context structures */
	struct topaz_dev_ctx *dev_handle;
	struct lst_t	topaz_stream_list;
	vxe_cb		vxe_str_processed_cb;
	uint32		num_pipes;
	void 		*mutex;
};

struct topaz_stream_context {
	void 	**link; /* List link (allows the structure to be part of a MeOS list).*/
	struct topaz_core_context *core_ctx;
	struct img_enc_context *enc_ctx;
	uint32 	stream_id;			/* DMAN allocated device ID. */
	struct vxe_enc_ctx *vxe_ctx;
	void *mmu_ctx; /* stream specific MMU context */

};

/*
 * Function pointer type for picture management functions
 */
typedef void (*pic_mgmt_func)(void* app_context, uint32 frame_num);

/*
 * @function	InitHardware
 * @brief	Initialise the Encoder Hardware
 * @details 	Reset the hardware and set up registers, etc.
 */
int32 init_topaz_core(void *dev_handle, uint32 *num_pipes, uint32 mmu_flags, void *callback);

/*
 * @function		DeinitHardware
 */
int32  deinit_topaz_core(void);

/*
 * @function		CreateContext
 * @brief		Create an encoder context
 * @details  		Set up an encoder context with the given parameters
 */
int32 topaz_stream_create(void *vxe_ctx, struct img_video_params *video_params, uint8 base_pipe,
				uint8 pipes_to_use, struct img_rc_params *rc_params, void **topaz_str_context);

int32 topaz_end_of_stream(void *topaz_str_ctx, uint32 frame_cnt);

int32 topaz_flush_stream(void *topaz_str_ctx, uint32 frame_cnt);

int32 topaz_stream_destroy(void *topaz_str_ctx);

/*
 * Load the given context onto the hardware
 */
int32 topaz_load_context(void *topaz_str_ctx);

/*
 * Store the context from the hardware into given location
 */
int32 topaz_store_context(void *topaz_str_ctx);

/*
 * Destroy the given context onto the hardware
 */
int32 topaz_destroy_context(void *topaz_str_ctx);

/*
 * Get the capabilities of the encoder for the given requirements.
 * @param    standard		: Standard setting
 * @param    width		: Target output width
 * @param    height		: Target output height
 * @param    caps		: Pointer to caps structure to be filled in.
 */
int32 topaz_get_encoder_caps(enum img_standard standard, uint16 width,
			uint16 height, struct img_enc_caps *caps);


int32 topaz_stream_map_buf_sg(void *topaz_str_ctx, enum venc_buf_type buf_type,
			struct vidio_ddbufinfo *buf_info, void *sgt);

int32 topaz_stream_unmap_buf_sg(void *topaz_str_ctx, struct vidio_ddbufinfo *buf_info);

/*
 * Prepare a partially coded H264 Sequence Header (SPS).
 * @param    mb_width				: Width of the sequence in MBs
 * @param    mb_height			: Height of the sequence in MBs
 * @param    vui_params_present	: IMG_TRUE to include VUI parameters
 * @param    params				: Pointer to VUI parameters structure
 * @param    crop				: Pointer to crop parameter structure
 * @param    sh_params			: Pointer to sequence header params structure
 */
int32 topaz_h264_prepare_sequence_header(void *topaz_str_ctx, uint32 mb_width, uint32 mb_height,
					       osa_bool vui_params_present, struct h264_vui_params *params,
					       struct h264_crop_params *crop,
					       struct h264_sequence_header_params *sh_params, osa_bool mvc_sps);
/*
 * Prepare a partially coded H264 Picture Header (PPS).
 * @param		cqp_offset			: Chroma QP offset
 */
int32 topaz_h264_prepare_picture_header(void *topaz_str_ctx, int8 cqp_offset);

/*
 * Prepare an AUD header.
 */
int32 topaz_h264_prepare_aud_header(void *topaz_str_ctx);

/*
 * Set offsets and strides for YUV components.
 * @param		frame				: Source frame
 */
int32 topaz_set_component_offsets(void *topaz_str_ctx, struct img_frame *frame);

/*
 * Reserves a slot to be used by a subsequent call to SendCodedPackageToFW.
 * If internally allocated coded buffers are being used, it also gets a buffer
 * from the encoder's internal list.
 */
int32 topaz_reserve_coded_package_slot(void *topaz_str_ctx);

/*
 * Submits a buffer to the encoder to receive coded data along with a coded header buffer.
 * A VP8 non coded buffer can also be sent.
 * @param	coded_buffer			: Pointer to the coded package to send to FW
 */
int32 topaz_send_coded_package(void *topaz_str_ctx, struct img_coded_buffer *coded_buffer);

/*
 * Returns the number of empty source slots available
 * @return   uint8			: Number of empty source slots  (negative number indicates an error)
 */
int8 topaz_query_empty_source_slots(void *topaz_str_ctx);

/*
 * Returns the number of empty coded buffer slots available
 * @return   int8			: Number of empty coded slots (negative number indicates an error)
 */
int8 topaz_query_empty_coded_slots(void *topaz_str_ctx);

/*
 * Reserves a slot to be used by a subsequent call to SendSourceFrame.
 * If internally allocated source buffers are being used, it also gets a buffer
 * from the encoder's internal list.
 * @param		src_slot_num		: Pointer to receive slot number
 */
int32 topaz_reserve_source_slot(void *topaz_str_ctx, uint8 *src_slot_num);

/*
 * Submits a frame to the encoder for processing
 * @param		src_frame			: Pointer to receive buffer pointer
 * @param		frame_num		: Frame number of the given frame
 * @param		ctx_value	: Value which will be insert into coded data buffer header
 */
int32 topaz_send_source_frame(void *topaz_str_ctx, struct img_frame *src_frame,
				    uint32 frame_num, uint64 ctx_value);

/*
 * Indicates that there are no more source frames to send. It may not be the last
 * command, but it should inform the drivers about the length of the video stream.
 */
int32 topaz_end_of_stream(void *topaz_str_ctx, uint32 frame_count);

/*
 * Indicates that the encoder should be flushed after the specified number of
 * frames have been encoded.
 * @param    frame_count	: Number of frames which should have been encoded when the flush is complete
 */
int32 topaz_flush_stream(void *topaz_str_ctx, uint32 frame_count);

/*
 * Get the maximum coded data length for the given parameters, which can be used
 * to determine the size of the coded data buffer.
 */
uint32 topaz_get_coded_buffer_max_size(void *topaz_str_ctx, enum img_standard standard,
					uint16 width, uint16 height, struct img_rc_params *rc_params);

uint32 topaz_get_coded_package_max_num(void *topaz_str_ctx, enum img_standard standard,
					uint16 width, uint16 height, struct img_rc_params *rc_params);

/*
 * Tell the firmware to encode a frame.
 */
int32 topaz_encode_frame(void *topaz_str_ctx);

/*
 * Tells whether or not a pipe is being used by any context.
 * If it is being used then it returns the id (1 or 2) of the context that is using it.
 * Else it returns zero as the context id.
 */
int32 topaz_get_pipe_usage(uint8 pipe, uint8 *ctx_id);

#endif
